
#include "ChatFilter.h"

#include <stdlib.h>
#include <string.h>
#include <sys/select.h>
#include <termios.h>
#include <sstream>

struct termios orig_termios;

void reset_terminal_mode()
{
    tcsetattr(0, TCSANOW, &orig_termios);
}

void set_conio_terminal_mode()
{
    struct termios new_termios;

    /* take two copies - one for now, one for later */
    tcgetattr(0, &orig_termios);
    memcpy(&new_termios, &orig_termios, sizeof(new_termios));

    /* register cleanup handler, and set the new terminal mode */
    atexit(reset_terminal_mode);
    cfmakeraw(&new_termios);
    tcsetattr(0, TCSANOW, &new_termios);
}

int kbhit()
{
    struct timeval tv = { 0L, 0L };
    fd_set fds;
    FD_ZERO(&fds);
    FD_SET(0, &fds);
    return select(1, &fds, NULL, NULL, &tv);
}

int getch()
{
    int r;
    unsigned char c;
    if ((r = read(0, &c, sizeof(c))) < 0) {
        return r;
    } else {
        return c;
    }
}

int main()
{
	set_conio_terminal_mode();
	
	// connect to chat filter and send many requests
	Dreamworld::ChatFilter *pChatFilter = new Dreamworld::ChatFilter();
	
	printf("Starting process...\n\r");
	
	Dreamworld::ChatDataInterface::MsgList_t msgList;
	bool bContinue = true;
	while( bContinue )	
	{
		pChatFilter->Update();
		if(kbhit()) 
		{
			switch( getch() )
			{
			case '1':
			{
				Dreamworld::ChatFilterMessage *pMsg = new Dreamworld::ChatFilterMessage;
				msgList.push_back(pMsg);
				pMsg->m_strText = "65:65:This is a test!";
				pChatFilter->AddMessage(pMsg);				
			}
			break;
			case '2':
			for( int i = 0; i < 100; ++i )
			{
				Dreamworld::ChatFilterMessage *pMsg = new Dreamworld::ChatFilterMessage;
				msgList.push_back(pMsg);
				std::stringstream s;
				s << "65:65:This is a test! (#" << i << ")";
				pMsg->m_strText = s.str();
				pChatFilter->AddMessage(pMsg);				
			}
				break;
			case '3':
				
				break;
			case 'q':
				bContinue = false;
				break;
			};			
		}		
	}
	
	printf("Stopped process...\n\r");
	
	Dreamworld::ChatDataInterface::MsgList_t::iterator iter_cur = msgList.begin();
	Dreamworld::ChatDataInterface::MsgList_t::iterator iter_end = msgList.end();
	for( ; iter_cur != iter_end; ++iter_cur )
		(*iter_cur)->Release();
	msgList.clear();
	
	return 0;
}






















